/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import javax.swing.JComponent;

class FSKasten extends JComponent implements MouseListener {
	// Wird nur einmal erzeugt, daher Laden der Bilder im Konstruktor

	public FSKasten () {
		kasten = Tools.loadImage ("fs_kasten");
		
		addMouseListener (this);

		hebel = new FSHebel[6];
		hebel[0] = new FSHebel (this,  20, 140, "fs_1", Fahrstrasse.fs[0], Fahrstrasse.fs[1]);
		hebel[1] = new FSHebel (this,  80, 140, "fs_2", Fahrstrasse.fs[2], Fahrstrasse.fs[3]);
		hebel[2] = new FSHebel (this, 140, 140, "fs_3", Fahrstrasse.fs[4], Fahrstrasse.fs[5]);
		hebel[3] = new FSHebel (this, 200, 140, "fs_4", Fahrstrasse.fs[6], Fahrstrasse.fs[7]);
		hebel[4] = new FSHebel (this, 260, 140, "fs_5", Fahrstrasse.fs[8], Fahrstrasse.fs[9]);
		hebel[5] = new FSHebel (this, 320, 140, "fs_6", Fahrstrasse.fs[10], Fahrstrasse.fs[11]);
		
		gl_anz = new Gleisanzeige[3];
		gl_anz[0] = new Gleisanzeige (this, 140, 128);
		gl_anz[1] = new Gleisanzeige (this, 200, 128);
		gl_anz[2] = new Gleisanzeige (this, 260, 128);
		
		block_lampe = new Lampe[6];
		block_lampe[0] = new Lampe (this, 40, 15, Color.YELLOW);
		block_lampe[1] = new Lampe (this, 70, 15, Color.YELLOW);
		block_lampe[2] = new Lampe (this, 100, 15, Color.BLUE);
		block_lampe[3] = new Lampe (this, 360, 15, Color.YELLOW);
		block_lampe[4] = new Lampe (this, 330, 15, Color.YELLOW);
		block_lampe[5] = new Lampe (this, 300, 15, Color.BLUE);
		
		bk = new Block[2];
		bk[0] = new Block();
		bk[1] = new Block();

		bk[0].setzeParameter(Hauptfenster.anz.l[23], Hauptfenster.anz.l[22], Hauptfenster.anz.l[25], Hauptfenster.anz.l[24], block_lampe[0], block_lampe[1], block_lampe[2]);
		bk[1].setzeParameter(Hauptfenster.anz.l[27], Hauptfenster.anz.l[26], Hauptfenster.anz.l[29], Hauptfenster.anz.l[28], block_lampe[3], block_lampe[4], block_lampe[5]);

		taste = new Drehtaste[2];
		taste[0] = new Drehtaste(this, 100, 65);
		taste[1] = new Drehtaste(this, 300, 65);
	}
	
	public void paint (Graphics g) {
		int i;
		
		g.drawImage (kasten, 0, 0, this);
		for (i = 0; i < 6; i++) {
			hebel[i].paint(g);
			block_lampe[i].paint(g);
		}
		for (i = 0; i < 3; i++) {
			gl_anz[i].paint(g);
		}
		taste[0].paint(g);
		taste[1].paint(g);
	}

	public void repaintHebel (int id) {
//		Graphics g = getGraphics ();
//		hebel[id].paint (g);
		repaint();
	}
	
	public void repaintTaste (int id) {
//		Graphics g = getGraphics ();
//		taste[id].paint(g);
		repaint();
	}
	
	public void mouseClicked (MouseEvent e) {
		if (e.getY() > 100) {
			if (e.getX() < 20 || e.getX() > 380) return;
			int ix = (e.getX() - 20) / 60;
			if (e.getY() > 140 && e.getY() < 175) hebel[ix].hebelOben();
			else if (e.getY() >= 175 && e.getY() <= 205) hebel[ix].hebelMitte();
			else if (e.getY() > 205 && e.getY() < 240) hebel[ix].hebelUnten();
			else return;
			repaintHebel (ix);
		} else if (e.getY() > 50 && e.getY() < 80) {
			if (e.getX() > 25 && e.getX() < 55) {
				bk[0].rueckmelden();
			} else if (e.getX() > 55 && e.getX() < 85) {
				bk[0].freieBahnAnfordern();
			} else if (e.getX() > 85 && e.getX() < 115) {
				bk[0].freieBahnFesthalten();
				if (bk[0].freie_bahn_festgehalten) taste[0].einschalten();
				else taste[0].ausschalten();
				repaintTaste(0);
			} else if (e.getX() > 345 && e.getX() < 375) {
				bk[1].rueckmelden();
			} else if (e.getX() > 315 && e.getX() < 345) {
				bk[1].freieBahnAnfordern();
			} else if (e.getX() > 285 && e.getX() < 315) {
				bk[1].freieBahnFesthalten();
				if (bk[1].freie_bahn_festgehalten) taste[1].einschalten();
				else taste[1].ausschalten();
				repaintTaste(1);
			}
		}
	}
	
	public void mousePressed (MouseEvent e) { }
	public void mouseReleased (MouseEvent e) { }
	public void mouseEntered (MouseEvent e) { }
	public void mouseExited (MouseEvent e) { }
	
	BufferedImage kasten;
	FSHebel hebel[];
	public static Gleisanzeige gl_anz[];
	public static Lampe block_lampe[];
	
	Drehtaste taste[];
	
	public Block bk[];
	
	static final long serialVersionUID = 2909995093749132236L;
}

