/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.JComponent;

class Hauptfenster extends JComponent {
	public Hauptfenster () {
		super();
		setLayout (null);
		setBackground (Color.BLACK);
		initialisieren ();
		setPreferredSize (new Dimension(1000, 700));
	}
	
	public void initialisieren () {
		int i;
		anz = new Anzeige ();
		anz.setSize(1000, 200);
		anz.setLocation(0, 0);
		add(anz);
//		setSize (1000, 700);
		
		anz.l[8].einschalten();
		anz.l[11].einschalten();
		anz.l[14].einschalten();
		anz.l[17].einschalten();
		anz.l[23].einschalten();
		anz.l[27].einschalten();
		
		fs_kasten = new FSKasten ();
		fs_kasten.setSize (400,500);
		fs_kasten.setLocation(600, 200);
		add(fs_kasten);
		
		hebel = new Hebel[10];
		hebel[0]  = new Weichenhebel (0, "ns_1", Fahrstrasse.iso_tab_weichen[0]);
		Fahrstrasse.wh[0] = (Weichenhebel)hebel[0];
		hebel[1]  = new Weichenhebel (1, "ns_2Sp", Fahrstrasse.iso_tab_weichen[1]);
		Fahrstrasse.wh[1] = (Weichenhebel)hebel[1];
		hebel[2]  = new Signalhebel (2, "ns_A", true, anz.sig[0], fs_kasten.bk[0], false);
		Fahrstrasse.sh[0] = (Signalhebel)hebel[2];
		hebel[3]  = new Durchfahrsignalhebel (3, "ns_Ad");
		hebel[4]  = new Signalhebel (4, "ns_B", false, anz.sig[1], fs_kasten.bk[0], true);
		Fahrstrasse.sh[1] = (Signalhebel)hebel[4];
		hebel[5]  = new Signalhebel (5, "ns_C", false, anz.sig[2], fs_kasten.bk[1], true);
		Fahrstrasse.sh[2] = (Signalhebel)hebel[5];
		hebel[6]  = new Durchfahrsignalhebel (6, "ns_Dd");
		hebel[7]  = new Signalhebel (7, "ns_D", true,anz.sig[3], fs_kasten.bk[1], false);
		Fahrstrasse.sh[3] = (Signalhebel)hebel[7];
		hebel[8]  = new Weichenhebel (8, "ns_34", Fahrstrasse.iso_tab_weichen[2]);
		Fahrstrasse.wh[2] = (Weichenhebel)hebel[8];
		hebel[9]  = new Weichenhebel (9, "ns_5", Fahrstrasse.iso_tab_weichen[3]);
		Fahrstrasse.wh[3] = (Weichenhebel)hebel[9];
		
		((Signalhebel)hebel[2]).setASig(anz.sig[2]);
		((Signalhebel)hebel[7]).setASig(anz.sig[1]);
		((Durchfahrsignalhebel)hebel[3]).setParams(Fahrstrasse.fs[0], (Signalhebel)hebel[5]);
		((Durchfahrsignalhebel)hebel[6]).setParams(Fahrstrasse.fs[10], (Signalhebel)hebel[4]);
		
		for (i = 0; i < 10; i++) {
			add(hebel[i]);
			hebel[i].setLocation(i * 60, 200);
			hebel[i].setSize(60, 500);
		}

		/*
		bktf1 = new BlockTestFrame (fs_kasten.bk[0], "Block Kesswil");
		bktf1.setVisible(true);
		bktf2 = new BlockTestFrame  (fs_kasten.bk[1], "Block Altnau");
		bktf2.setVisible(true);
		*/
		
		r = new SpurElement[25];
		
		r[0] = fs_kasten.bk[0];
		r[1] = new Gleis();
//		r[2] = new FSWeiche(1);
		r[2] = new Weiche(1);
		r[3] = new Gleis();
		r[4] = new Weiche(2);
		r[5] = new SpurElement();
		r[6] = new SpurElement();
		r[7] = new SpurElement();
		r[8] = new Weiche(4);
		r[9] = new SpurElement();
		r[10] = new Gleis();
		r[11] = new Gleis();
//		r[12] = new Weiche(5);
		r[12] = new Weiche(5);
		r[13] = new SpurElement();
		r[14] = fs_kasten.bk[1];
		r[15] = anz.sig[0];
		r[16] = new Signalhalt();
		r[17] = new Signalhalt();
		r[18] = new Signalhalt();
		r[19] = new Signalhalt();
		r[20] = new Signalhalt();
		r[21] = new Signalhalt();
		r[22] = anz.sig[3];
		r[23] = anz.sig[1];
		r[24] = anz.sig[2];
		
		((Block) r[0]).initRoute(null, r[15], 2000);
		((Gleis) r[1]).initRoute(anz.l[4], r[15], r[23], 50);
		((Weiche)r[2]).initRoute(anz.l[0], r[23], r[4], r[3], true, 50);
//		((FSWeiche)r[2]).initSignale((Signalhebel)hebel[2], (Signalhebel)hebel[4]);
//		((FSWeiche)r[2]).initRoute(anz.l[0], r[23], r[4], r[3], true, 50);
		((Gleis) r[3]).initRoute(anz.l[5], r[2], r[18], 50);
		((Weiche)r[4]).initRoute(anz.l[1], r[2], r[17], r[16], true, 50);
		r[5].initRoute (r[16], r[19], 250);
		r[6].initRoute (r[17], r[8], 250);
		r[7].initRoute (r[18], r[21], 450);
		((Weiche)r[8]).initRoute(anz.l[2], r[9], r[6], r[19], false, 50);
		r[9].initRoute (r[8], r[20], 150);
		((Gleis)r[10]).initRoute(anz.l[6], r[20], r[12], 50);
		((Gleis)r[11]).initRoute(anz.l[7], r[21], r[12], 50);
//		((FSWeiche)r[12]).initRoute(anz.l[3], r[24], r[10], r[11], false, 50);
//		((FSWeiche)r[12]).initSignale((Signalhebel)hebel[7], (Signalhebel)hebel[5]);
		((Weiche)r[12]).initRoute(anz.l[3], r[24], r[10], r[11], false, 50);
		r[13].initRoute (r[24], r[22], 50);
		((Block)r[14]).initRoute(r[22], null, 2000);
		
		
		((Signal)r[15]).initRoute(r[0], r[1], true);
		((Signalhalt)r[16]).initRoute(anz.sig[1], r[4], r[5], false);
		((Signalhalt)r[17]).initRoute(anz.sig[1], r[4], r[6], false);
		((Signalhalt)r[18]).initRoute(anz.sig[1], r[3], r[7], false);
		((Signalhalt)r[19]).initRoute(anz.sig[2], r[5], r[8], true);
		((Signalhalt)r[20]).initRoute(anz.sig[2], r[9], r[10], true);
		((Signalhalt)r[21]).initRoute(anz.sig[2], r[7], r[11], true);
		((Signal)r[22]).initRoute(r[13], r[14], false);
		
		((Signal)r[23]).initRoute(r[1], r[2], false);
		((Signal)r[24]).initRoute(r[12], r[13], true);
		
		((Weichenhebel)hebel[0]).setWeiche((Weiche)r[2]);
		((Weichenhebel)hebel[1]).setWeiche((Weiche)r[4]);
		((Weichenhebel)hebel[8]).setWeiche((Weiche)r[8]);
		((Weichenhebel)hebel[9]).setWeiche((Weiche)r[12]);
		
		Fahrstrasse.iso[0] = r[1];	// 1u
		Fahrstrasse.iso[1] = r[2];	// 1
		Fahrstrasse.iso[2] = r[4];	// 2
		Fahrstrasse.iso[3] = r[3];	// 1y
		Fahrstrasse.iso[4] = r[8];	// 4
		Fahrstrasse.iso[5] = r[10];	// 5x
		Fahrstrasse.iso[6] = r[11];	// 5y
		Fahrstrasse.iso[7] = r[12];	// 5
		
		((GleisLampe)anz.l[0]).setIsolierung(r[2]);
		((GleisLampe)anz.l[1]).setIsolierung(r[4]);
		((GleisLampe)anz.l[2]).setIsolierung(r[8]);
		((GleisLampe)anz.l[3]).setIsolierung(r[12]);
		((GleisLampe)anz.l[4]).setIsolierung(r[1]);
		((GleisLampe)anz.l[5]).setIsolierung(r[3]);
		((GleisLampe)anz.l[6]).setIsolierung(r[10]);
		((GleisLampe)anz.l[7]).setIsolierung(r[11]);
		
		anz.initBlock (fs_kasten.bk[0], fs_kasten.bk[1]);
		((Signalhebel)hebel[2]).setBlockIso(r[2]);
		((Signalhebel)hebel[4]).setBlockIso(r[2]);
		((Signalhebel)hebel[5]).setBlockIso(r[12]);
		((Signalhebel)hebel[7]).setBlockIso(r[12]);
	}
	
	public void repaintHebel (int id) {
		hebel[id].repaint();
	}
		
	public static Anzeige anz;	// Muss static public sein, wegen den Lampen...
	public static FSKasten fs_kasten;	// Dasselbe...
	
	Hebel hebel[];
	
//	BlockTestFrame bktf1, bktf2;
	
	SpurElement r[];
	
	protected boolean hebelsperre_frei;
	
	static final long serialVersionUID = 4336720779563234876L;
}
